#pragma once

#include <cppargs/group/group.h>
#include <cppargs/options/option.h>

namespace cppargs
{

    struct printing
    {
    public:
        /**
         * @brief Print the passed group to the passed stream.
         *
         * @param[in] os    Stream to print group to.
         * @param[in] g     Group to print to stream.
         */
        inline void operator()(std::ostream& os, const group& g) const;

    private:
        /**
         * @brief Print the passed group to the passed stream.
         *
         * @param[in] os    Stream to print group to.
         * @param[in] g     Group to print to stream.
         */
        inline void print_group(std::ostream& os, const group& g) const;

        /**
         * @brief Print the passed option to the passed stream.
         *
         * @param[in] os    Stream to print group to.
         * @param[in] o     Option to print to stream.
         */
        inline void print_option(std::ostream& os, const option& o) const;
    };

}
