#pragma once

#include <cppargs/options/option.h>

namespace cppargs
{
    template<typename T_instance>
    struct instance_owner
    {
        virtual T_instance* instance() const = 0;
    };

    template<typename T_instance>
    struct member_option
        : public option
    {
    public:
        using base_type     = option;
        using instance_type = T_instance;
        using owner_type    = instance_owner<instance_type>;

    private:
        template<typename X, typename Y, typename Z>
        friend struct member_group;

        owner_type* _owner;

    public:
        using option::option;

    protected:
        /**
         * @brief Get the current instance of the object to parse.
         *
         * @return Current instance of the object to parse.
         */
        inline instance_type& instance() const;
    };

}
