#pragma once

#include <cppargs/options/member/member_predicate_option.h>

namespace cppargs
{

    template<typename T_instance, typename T_predicate>
    template<typename... T_args>
    member_predicate_option<T_instance, T_predicate>::member_predicate_option(
        const option_meta& p_meta,
        T_args&&... args)
        : base_type (p_meta)
        , _predicate(std::forward<T_args>(args)...)
        { }

    template<typename T_instance, typename T_predicate>
    void member_predicate_option<T_instance, T_predicate>::parse(context& c) const
        { _predicate(this->instance(), c); }

}
