#pragma once

#include "simple_predicate_option.h"

namespace cppargs
{

    template<typename T_predicate>
    template<typename... T_args>
    simple_predicate_option<T_predicate>::simple_predicate_option(
        const option_meta& p_meta,
        T_args&&... args)
        : simple_option(p_meta)
        , _predicate(std::forward<T_args>(args)...)
        { }

    template<typename T_predicate>
    void simple_predicate_option<T_predicate>::parse(context& c) const
        { _predicate(c); }

}
